#include "Accelerometer.h"

float f_map(float x, float in_min, float in_max, float out_min, float out_max)
{
  return (x - in_min) * (out_max - out_min) / (in_max - in_min) + out_min;
}

Accelerometer :: Accelerometer(uint16_t _id) {
    x_accel_pin = X_ACCEL_PIN;
    y_accel_pin = Y_ACCEL_PIN;
    z_accel_pin = Z_ACCEL_PIN;
    type = SENSOR_TYPE_ACCELEROMETER;
    id = _id;
}

Accelerometer :: ~Accelerometer() {}

void Accelerometer :: Pin_Initialise() {
    pinMode(x_accel_pin,INPUT);
    pinMode(y_accel_pin,INPUT);
    pinMode(z_accel_pin,INPUT);
}

void Accelerometer :: Sensor_Initialise() {
    /* accel_data.sens_type = ACCEL_TYPE; */
    /* accel_data.isens_info = 0; */
    accel_data.x = 0;
    accel_data.y = 0;
    accel_data.z = 0;
    /* accel_data.csens_info = '\0'; */
}

void Accelerometer :: Read_Accelerometer() {
    int x_raw = analogRead(x_accel_pin);
    int y_raw = analogRead(y_accel_pin);
    int z_raw = analogRead(z_accel_pin);

    accel_data.x = x_raw;
    accel_data.y = y_raw;
    accel_data.z = z_raw;

    /* float x_raw = analogRead(x_accel_pin); */
    /* float y_raw = analogRead(y_accel_pin); */
    /* float z_raw = analogRead(z_accel_pin); */

    /* x_raw = f_map(x_raw, 0.0f, ACCELEROMETER_ADC_RANGE, -G_SCALE, G_SCALE); */
    /* y_raw = f_map(y_raw, 0.0f, ACCELEROMETER_ADC_RANGE, -G_SCALE, G_SCALE); */
    /* z_raw = f_map(z_raw, 0.0f, ACCELEROMETER_ADC_RANGE, -G_SCALE, G_SCALE); */

    /* accel_data.x = x_raw * GRAVITY; */
    /* accel_data.y = y_raw * GRAVITY; */
    /* accel_data.z = z_raw * GRAVITY; */
}

/* sensors_vec_t Accelerometer :: Get_Sensor_Info() { */
ivec_t Accelerometer :: Get_Sensor_Info() {
    return accel_data;
}

/* f_sensor_packet_t Accelerometer :: Get_Sensor_Packet() { */
i_sensor_packet_t Accelerometer :: Get_Sensor_Packet() {
    /* f_sensor_packet_t packet_out; */
    i_sensor_packet_t packet_out;
    packet_out.type = type;
    packet_out.id   = id;
    packet_out.acceleration = accel_data; // m/s^2

    /* Serial.print("x: "); Serial.print(  packet_out.acceleration.x); Serial.print("\t"); */
    /* Serial.print("y: "); Serial.print(  packet_out.acceleration.y); Serial.print("\t"); */
    /* Serial.print("z: "); Serial.println(packet_out.acceleration.z); */

    return packet_out;
}

