#include "Button_Master.h"

Button_Master::Button_Master () {
    start_time = 0;
    button_state = 0;
    prior_state = 0;
    type = SENSOR_TYPE_BUTTON;
}

Button_Master::~Button_Master() {}

void Button_Master::Button_Pin_Initialise(int _button_pin) {
    char finger = BUTTON_PINKY;
    button_pin = _button_pin;
    /* button_struct.sens_type = BUTTON_TYPE; */
    /* button_struct.isens_info = button_pin; */
    button_struct.pinky = 0;
    button_struct.ring = 0;
    button_struct.middle = 0;
    button_struct.index = 0;
    if (button_pin == GREEN_READ_PIN) {
        finger = BUTTON_PINKY;
    } else if (button_pin == RED_READ_PIN) {
        finger = BUTTON_RING;
    } else if (button_pin == YELLOW_READ_PIN) {
        finger = BUTTON_MIDDLE;
    } else if (button_pin == BLUE_READ_PIN) {
        finger = BUTTON_INDEX;
    }
    /* button_struct.csens_info = finger; */
    // Pull-down resistors
    digitalWrite(button_pin,LOW);
    pinMode(button_pin,INPUT);
}

void Button_Master::Read_Button_State() {
    button_state = digitalRead(button_pin);
}

/* Assumes that this will only be done at the end of the loop */
void Button_Master::Set_Prior_State(bool _read_state) {
    prior_state = _read_state;
}

void Button_Master::Set_Start_Time(int _start_time){
    start_time = _start_time;
}

bool Button_Master::Get_Button_State() {
    return button_state;
}

int Button_Master::Get_Button_Pin() {
    return button_pin;
}

bool Button_Master::Get_Prior_State() {
    return prior_state;
}

sensors_u08_t Button_Master::Get_Sensor_Info() {
    return button_struct;
}

bool Button_Master::Button_Timing(){
    int duration = millis() - start_time;
    if ((duration > BOUNCE_MS) && (duration < SHORT_PRESS)) {
        return true;
    } else {
        return false;
    }
}

u08_sensor_packet_t Button_Master::Get_Sensor_Packet() {
    u08_sensor_packet_t packet_out;
    packet_out.type = type;
    packet_out.button = button_struct;
    return packet_out;
}
