#ifndef BUTTON_MASTER_H
#define BUTTON_MASTER_H

#include <stdio.h>
#include <time.h>
#include "Configuration.h"
#include "Sensor.h"
#include <Arduino.h>

using namespace std;

// A class for controlling the passcodes for a puzzle box given a set sequence
// length. This class is for each button that is available.
class Button_Master {
    private:
        int start_time;
        bool button_state;
        bool prior_state;
        sensors_u08_t button_struct;
        sensors_type_t type;
        int button_pin;
    public:
        Button_Master();
        ~Button_Master();
        void Button_Pin_Initialise(int button_pin_alloc);
        void Set_Start_Time(int _start_time);
        void Read_Button_State();
        void Set_Prior_State(bool _read_state);
        int Get_Button_Pin();
        bool Get_Button_State();
        bool Get_Prior_State();
        sensors_u08_t Get_Sensor_Info();
        bool Button_Timing();
        u08_sensor_packet_t Get_Sensor_Packet();
};
#endif
