/*****************************************************************************************************
 * PIN LAYOUT
 * This file is used by other classes to define the pins used for the hardware.
 *****************************************************************************************************/
#ifndef CONFIGURATION_H
#define CONFIGURATION_H

#include <Arduino.h>

/* Runtime Configuration */
#define DELAY               0

/* Debug Options */
#define DEBUG               0

/* Serial Options */
#define BAUDRATE            115200
#define PING                '1'

/* =================================== */
/* Pin layout */
/* =================================== */
/* Button Pins */
#define NUM_BUTTON_PINS      4
#define BLUE_READ_PIN       24
#define YELLOW_READ_PIN     28
#define RED_READ_PIN        32
#define GREEN_READ_PIN      36

/* IMU Pins */
#define NUM_IMU_PINS         3
#define X_ACCEL_PIN         A0
#define Y_ACCEL_PIN         A1
#define Z_ACCEL_PIN         A2

/* =================================== */
/* Resolution */
/* =================================== */
#define ADC_RES             1024

/* Buffer len */
#define DEFAULT_BUFFER_LEN  2560
#define COMBINATION_LEN     3

// Left hand configuration for now
/* map<int,char> button_finger_dict; */
/* button_finger_dict.insert(GREEN_READ_PIN,'P');  // Pinky */
/* button_finger_dict.insert(RED_READ_PIN,'R');    // Ring */
/* button_finger_dict.insert(YELLOW_READ_PIN,'M'); // Middle */
/* button_finger_dict.insert(BLUE_READ_PIN,'I');   // Index */

/* map<string,int> sens_type_dict; */
/* sens_type_dict.insert(std::make_pair("button",0)); */

#endif
