#include "Button_Master.h"
#include "Puzzle_Module.h"
#include "Configuration.h"
#include "Accelerometer.h"
#include "Serial_Communication.h"

#include <stdio.h>
#include <stdlib.h>

unsigned long switch_hi_time = 0;
unsigned long switch_diff = 0;
unsigned long switch_add = 0;

int start_time;
unsigned int buff_size;

String out_string;

bool read_val;

Serial_Communication SC;
Button_Master BM_Arr[NUM_BUTTON_PINS];
uint8_t accel_id = 2;
Accelerometer Accel(accel_id);

int* buffer;
const int button_pin_alloc[] = {GREEN_READ_PIN,RED_READ_PIN,
                        YELLOW_READ_PIN, BLUE_READ_PIN};

ivec_t accel_vec;
int vec_size = 0;
/* sensors_vec_t accel_vec; */
i_sensor_packet_t accel_pkt;
/* i_sensor_packet_t accel_update_pkt; */
const unsigned char out_buffer[DEFAULT_BUFFER_LEN];
/* i_sensor_packet_t accel_pkt[128]; */
/* f_sensor_packet_t accel_pkt; */

int buff_ind = 0;

bool state_change=0;
bool read_state = 0;
bool prior_state = 0;

char serial_in;

int newline[3] = {1, 2, 3};
const int *sendout;

using namespace std;

void setup() {
    sendout = newline;
    SC.Serial_Setup();

    buffer = (int*) malloc(DEFAULT_BUFFER_LEN);
    if (!buffer) {
        Serial.println("Memory allocation failed");
    }
    for (int i = 0; i < NUM_BUTTON_PINS; i++) {
        BM_Arr[i].Button_Pin_Initialise(button_pin_alloc[i]);
    }
    Accel.Pin_Initialise();
    Accel.Sensor_Initialise();
    
    pinMode(LED_BUILTIN,OUTPUT);

    analogReference(EXTERNAL);
    analogRead(0);

    Serial.println("end setup");
}

void loop() {
    /* char print_buffer [50]; */
    for (int i = 0; i<NUM_BUTTON_PINS; i++) {
        // read the states of the buttons
        BM_Arr[i].Read_Button_State();
    }
    for (int i = 0; i<NUM_BUTTON_PINS; i++) {
        read_state = BM_Arr[i].Get_Button_State();
        prior_state = BM_Arr[i].Get_Prior_State();
        // Button state has changed
        if (read_state ^ prior_state) {
            if (prior_state == 0) {
                start_time=millis();
                BM_Arr[i].Set_Start_Time(start_time);
            } else {
                if (BM_Arr[i].Button_Timing()) {
                    buff_ind += 1;
                    // if buffer at end of array...
                    if (!(buff_ind < DEFAULT_BUFFER_LEN)) {
                        // copy the last puzzle_length - 1 values to the beginning
                        // of buffer then wipe out the buffer
                        buff_ind = COMBINATION_LEN;
                        for (int j = 0; j < buff_ind-1; j++) {
                            buffer[j] = buffer[DEFAULT_BUFFER_LEN - 
                                                (buff_ind - 1) + j];
                            if (DEBUG) {
                                Serial.print(j+1);Serial.print(" ");
                                Serial.print(buffer[j]); Serial.print(", ");
                            }
                        }
                    }
                    buffer[buff_ind] = BM_Arr[i].Get_Button_Pin();
                    /* SC.Send_Sensor_Info(BM_Arr[i].Get_Sensor_Info()); */
                }
            }
        }
        BM_Arr[i].Set_Prior_State(read_state);
    }

    Accel.Read_Accelerometer();
    /* SC.Send_Sensor_Info(Accel.Get_Sensor_Info()); */
    accel_vec = Accel.Get_Sensor_Info();
    accel_pkt = Accel.Get_Sensor_Packet();
    // I think i want to change this to memcpy to bytes and copy all the byte
    // wise information to a buffer that can be sent out rather than an array
    // of typedef int sensor info
    /* accel_pkt[vec_size] = Accel.Get_Sensor_Packet(); */

    /* SC.MessagePack(accel_pkt); */

    SC.Read_Update_Request();
    if (SC.Get_Update_Request()) {
        int size = SC.Send_i_Sensor_Packet( accel_pkt);
        /* vec_size = 0; */
        /* SC.Send_Packet(); */
        /* SC.Reset_Buffer(); */
    }
    SC.Set_Update_Request(0);

    /* vec_size += 1; */
    /* if (vec_size > sizeof(accel_pkt)/8){ */
    /*     vec_size = 0; */
    /* } */

    /* int size = Serial.write((byte*)&accel_pkt, sizeof(accel_pkt)); */
    /* Serial.print("type: "); */
    /* Serial.print(accel_pkt.type); Serial.print('\t'); */
    /* Serial.print("id: "); */
    /* Serial.print(accel_pkt.id); Serial.print('\t'); */ 
    /* Serial.print("x_a: "); */
    /* Serial.print(accel_pkt.acceleration.x); Serial.print('\t'); */
    /* Serial.print("y_a: "); */
    /* Serial.print( accel_pkt.acceleration.y); Serial.print('\t'); */
    /* Serial.print("z_a: "); */
    /* Serial.print( accel_pkt.acceleration.z); Serial.print('\t'); */ 

    delay(DELAY);
}
