#ifndef SERIAL_COMMUNICATION_H
#define SERIAL_COMMUNICATION_H

#include "Configuration.h"
#include "Sensor.h"
#include <Arduino.h>

class Serial_Communication {
    public:
        Serial_Communication();
        ~Serial_Communication();
        void Serial_Setup();
        void Read_Update_Request();
        void Set_Update_Request(bool _update_request);
        //void Send_Sensor_Info(sensor _sense_data);

        /*  Protocol: header, data, checksum
         *  Header: uint08 type, see Sensor.h
        */
        int MessagePack(i_sensor_packet_t packet_out);
        void Reset_Buffer();
        int Send_Packet();
        int Send_u08_Sensor_Packet(u08_sensor_packet_t packet_out);
        int Send_f_Sensor_Packet(f_sensor_packet_t packet_out);
        int Send_i_Sensor_Packet(i_sensor_packet_t packet_out);

        bool Get_Update_Request();
    private:
        char serial_in;
        bool update_request;
        // a byte is 8 bits 0xFF is 255, represented in 8 bits.
        uint16_t checksum; 
        uint16_t header;
        uint16_t end_byte;
        uint16_t message_size;
        const unsigned char send_pkt[2560];
        unsigned char *ptr;
};

#endif
